//+------------------------------------------------------------------+
//|                                                 TickLaguerreFast.mq4 |
//|                                                     Emerald King |
//|                                     mailto:info@emerald-king.com |
//|                    mod by jaguar1637 at yahoo dotcom
//+------------------------------------------------------------------+
#property copyright "Emerald King"
#property link      "mailto:info@emerald-king.com"

#property indicator_separate_window

#property indicator_color1 DarkBlue

#property indicator_width1 2
#property indicator_level1 0.775
#property indicator_level2 0.50
#property indicator_level3 0.225
#property indicator_maximum 1
#property indicator_minimum 0
//---- input parameters

extern double gamma=0.2; // 0.7;
extern int MaxBars=525;

int LastTm;

double L0 = 0, L1 = 0, L2 = 0, L3 = 0, L0A = 0, L1A = 0, L2A = 0, L3A = 0, LRSI = 0, CU = 0, CD = 0;
double val1[];
//+------------------------------------------------------------------+
int init() {
   IndicatorDigits(2);
   IndicatorBuffers(1); 
   SetIndexBuffer(0,val1);
   SetIndexStyle(0,DRAW_LINE);

   string shortname="TickLaguerreFast("+DoubleToStr(gamma,2); shortname = shortname+")"; 
   IndicatorShortName(shortname);
   
   return(0); 
}
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
int start() {
   int i,j;
   double sum1=0;

        L0A = L0;
        L1A = L1;
        L2A = L2;
        L3A = L3;
        //L0 = (1 - gamma)*Close[i] + gamma*L0A;
        L0 = (1 - gamma)*((Ask+Bid)/2) + gamma*L0A;
        L1 = - gamma *L0 + L0A + gamma *L1A;
        L2 = - gamma *L1 + L1A + gamma *L2A;
        L3 = - gamma *L2 + L2A + gamma *L3A;
        //----
        CU = 0;
        CD = 0;
        //----
        if(L0 >= L1) 
            CU = L0 - L1; 
        else 
            CD = L1 - L0;
        //----
        if(L1 >= L2) 
            CU = CU + L1 - L2; 
        else 
            CD = CD + L2 - L1;
        //----
        if(L2 >= L3) 
            CU = CU + L2 - L3; 
        else 
            CD = CD + L3 - L2;
        //----
        if(CU + CD != 0) 
            LRSI = CU / (CU + CD);
            
          val1[i] = LRSI;        

   
      if (LastTm < Time[0]) {
         for (i = 0;i< MaxBars ;i++) 
            {
            val1[i] = val1[i+1];
            }
         LastTm = Time[0];   
      }
      for(i=MaxBars-1;i>=0;i--) 
         {
         val1[i+1] = val1[i];
      }

  
   return(0);
}
//+------------------------------------------------------------------+

